/* Return the inventory type of an inventory tag.  Not really a
   general purpose function.

  Copyright (C) 2003 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#include <string>
#include "arx_error.hpp"
#include "Command_Info.hpp"
#include "inventory_types.hpp"

inline inventory_types inventory_tag_type(const std::string &s,
                                          const Command_Info &info)
{
  if(s.empty())
    throw arx_error("Empty inventory tag",info);    
  switch(s[0])
    {
    case 'x':
    case 'i':
    case '?':
    case 'a':
    case 'w':
    case 'k':
      return source;
      break;
    case 'E':
    case 'D':
    case 'A':
      return control;
      break;
    default:
      throw arx_error("Unknown inventory tag type\n" + s,info);
      break;
    }
}
