/* Move all of the deletes and renames to their final resting place.

  Copyright (C) 2003 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/convenience.hpp"
#include "Moved_Path.hpp"
#include <list>
#include <sstream>

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

void move_original_away(const string &source, const string &destination,
                        list<pair<string,string> > &conflicts)
{
  /* If there is a conflict, rename the original to .orig.
     This may also conflict, so try .orig1, .orig2, ... until
     we find one that works. */
  stringstream orig(".orig");
  int counter(0);
  
  while(fs::exists(destination + orig.str()))
    {
      ++counter;
      orig.str();
      orig << ".orig" << counter;
    }
  
  conflicts.push_back(make_pair(destination, destination + orig.str()));
  fs::rename(source,destination + orig.str());
}

void move_original_away(const string &destination,
                        list<pair<string,string> > &conflicts)
{
  move_original_away(destination,destination,conflicts);
}
