/* Inventories a directory, but puts everything into the a particular
   category (control, precious, junk, etc.).  Useful for inventorying
   a directory that has already been determined to be control,
   precious, junk, etc.

   Copyright (C) 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <list>
#include "boost/filesystem/operations.hpp"
#include "file_attributes.hpp"
#include "Inventory_Flags.hpp"
#include "inventory_types.hpp"
#include "Command_Info.hpp"

extern void inventory_directory_as
(const boost::filesystem::path &directory,
 Inventory &result,
 const inventory_types &type,
 const Inventory_Flags &flags,
 const Command_Info &info,
 const bool &control_uses_names=false);

