/* Construct a tag from the path's name.

   Copyright (C) 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/fstream.hpp"
#include "get_option_from_file.hpp"
#include "Command_Info.hpp"
#include "tree_root.hpp"

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

string names_tag(const path &file_path,
                 const Command_Info &info)
{
  /* Construct a tag from the path's name */

  /* This probably breaks if inventorying the root directory "/" */

  if(file_path.string().size()>2 && file_path.string().substr(0,2)=="./")
    return file_path.string();
  else
    return string("." + complete(file_path).string().
                  substr(tree_root(file_path.branch_path(),info).string().size()));
}
