/* Checks whether a particular directory is categorized as
   source.

   Copyright (C) 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/fstream.hpp"
#include "boost/regex.hpp"
#include "Inventory_Flags.hpp"
#include "Inventory_Method.hpp"
#include "file_attributes.hpp"
#include "inventory_types.hpp"
#include "Inventory.hpp"

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

bool push_if_tagged_directory(const path &file_path,
                              Inventory &result,
                              const Inventory_Flags &flags,
                              const Command_Info &info)
{
  /* Check for explicit tags only, not naming conventions. */
  if(flags.inv_method==Inventory_Method::explicit_inventory
     || flags.inv_method==Inventory_Method::implicit_inventory)
    {
      const path id_path(file_path / ".arch-ids/=id");
      if(exists(id_path))
        {
          if(flags.source && flags.directories)
            result[source][arx_dir].
              push_back(file_attributes
                        (file_path,"x_" + get_option_from_file(id_path,info)));
          return true;
        }
    }
  return false;
}
