/* Prints out one category (source, control, precious, etc.)

   Copyright (C) 2001, 2002 Tom Lord
   Copyright (C) 2002, 2003 Walter Landry and the Regents of the
                                  University of California

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <list>
#include <string>
#include "Inventory_Flags.hpp"
#include "file_attributes.hpp"
#include "inventory_types.hpp"
#include "Command_Info.hpp"
#include "Inventory.hpp"

using namespace std;

extern 
void output_section(list<file_attributes> &section,
                    const string &report_title,
                    const char &prefix,
                    const bool &is_file,
                    const inventory_types &type,
                    const Inventory_Flags &flags,
                    const Command_Info &info);

void output_category(Inventory &inventory_result,
                     const string &report_title,
                     const char &prefix,
                     const inventory_types &type,
                     const Inventory_Flags &flags,
                     const Command_Info &info,
                     bool nested_tree=false)
{
  if(flags.files && !nested_tree)
    {
      output_section(inventory_result[type][arx_file],
                     report_title + " Files:",prefix,true,type,flags,info);
    }
  if(flags.directories)
    {
      output_section(inventory_result[type][arx_dir],report_title
                     + (nested_tree ? "" : " Directories:"),prefix,false,
                     type,flags,info);
    }
}

