/* Check whether an inventory has duplicate tags.  This assumes that
   the inventory is already sorted by tags.  This is a bit hacked and
   inefficient.

  Copyright (C) 2003 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#include "file_attributes.hpp"
#include "Command_Info.hpp"
#include "Inventory.hpp"
#include <list>
#include "arx_error.hpp"

using namespace std;

void check_duplicate_inventory_tags(const Inventory &inv,
                                    const Command_Info &info)
{
  list<file_attributes> duplicates;
  for(int m=0;m<2;++m)
    {
      /* Only source and control have tags */
      list<file_attributes> temp(inv[source][m]), temp2(inv[control][m]);
      duplicates.merge(temp,inventory_tag_cmp);
      duplicates.merge(temp2,inventory_tag_cmp);
    }
  const int full_size(duplicates.size());
  duplicates.unique(inventory_tag_eq);
  if(full_size!=duplicates.size())
    {
      throw arx_error("Duplicate inventory tags\nTry \"arx tree-lint --help\"",
                      info);
    }
}
