/* A quick and simple test just to see if two files are different.
   Lifted from the mkpatch-file-filter utility written by Karel
   Gardas.

   Copyright (C) 2002 Karel Gardas
   Minor Bug fix 2003 Walter Landry & the Regents of the University
                                          of California
   Copyright (C) 2003 Walter Landry
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.
   
   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include "boost/filesystem/fstream.hpp"
#include <vector>

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

bool same_contents(const path &f1, const path &f2)
{
  fs::ifstream stream1(f1, ios::in);
  fs::ifstream stream2(f2, ios::in);
  vector<char> buf1(65535);
  vector<char> buf2(65535);
  while(stream1.good() && stream2.good()) {
    stream1.read(&buf1[0], 65535);
    stream2.read(&buf2[0], 65535);
    if (stream1.gcount() != stream2.gcount()) {
      return false;
    }
    for (int i=0; i<stream1.gcount(); i++) {
      if (buf1[i] != buf2[i]) {
        return false;
      }
    }
  }
  return true;
}
