/* Copy all of the files in an inventory located in "original" into
   "destination".

  Copyright (C) 2001, 2002 Tom Lord
  Copyright (C) 2002, 2003 Walter Landry and the Regents
                           of the University of California
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#include "Inventory.hpp"
#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/exception.hpp"
#include "link_target.hpp"
#include <sys/stat.h>
#include "create_directory_and_parents.hpp"

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

void copy_inventory_files_dirs(const path &source, const path &destination,
                               Inventory &inv)
{
//   /* We always create the head directory. We can change this once we
//      implement dopatch. */
//   create_directory(destination);


//   for(int l=0;l<num_inventory_types;++l)
//     {
//       /* Sort the directories so that we make parents before children. */
//       inv[l][arx_dir].sort();
//       for(list<file_attributes>::const_iterator i=inv[l][arx_dir].begin();
//           i!=inv[l][arx_dir].end(); ++i)
//         {
//           /* Create a directory with specific permissions.  Very Unix
//              specific.  Should be implemented in boost, but they haven't
//              decided how to do it yet. */
          
//           cout << "mkdir " << (destination/i->file_path)
//             .native_directory_string() << endl;
          
//           /* Create parents as needed.  This should only create
//              parents that are not already in this inventory.  */

//           create_directory_and_parents((destination/i->file_path).
//                                        branch_path());

//           if ( ::mkdir((destination/i->file_path)
//                        .native_directory_string().c_str(),
//                        (i->permissions[8] ? S_IRUSR : 0) |
//                        (i->permissions[7] ? S_IWUSR : 0) |
//                        (i->permissions[6] ? S_IXUSR : 0) |
//                        (i->permissions[5] ? S_IRGRP : 0) |
//                        (i->permissions[4] ? S_IWGRP : 0) |
//                        (i->permissions[3] ? S_IXGRP : 0) |
//                        (i->permissions[2] ? S_IROTH : 0) |
//                        (i->permissions[1] ? S_IWOTH : 0) |
//                        (i->permissions[0] ? S_IXOTH : 0)) != 0)
//             boost::throw_exception
//               (fs::filesystem_error("hacked create_directory",
//                                     i->file_path,
//                                     fs::detail::system_error_code() ) );
//         }
//     }

  /* Next, copy the files over. */
  for(int l=0;l<num_inventory_types;++l)
    for(list<file_attributes>::const_iterator i=inv[l][arx_file].begin();
        i!=inv[l][arx_file].end(); ++i)
      {
        create_directory_and_parents((destination/i->file_path).branch_path());

        if(i->link)
          {
            /* For symlinks, just create a new symlink. */
            symlink(link_target(source/i->file_path),destination/i->file_path);
          }
        else
          {
            copy_file(source/i->file_path,destination/i->file_path);
          }
      }
}
