/* Remove directories that appear to be deleted and created with the
   same name.  This is just a directory that has been retagged.  The
   directory can stay, though the .arch-ids files will change.

  Copyright (C) 2003 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#include "Inventory.hpp"

void cull_retagged_directories(Inventory &orig_only, Inventory &mod_only)
{
  /* We only care about things that go into the archive, so only do
     source and control directories. */

  inventory_types type(source);
  for(int count=0; count<2; ++count)
    {
      Inventory_iterator i(orig_only[type][arx_dir].begin()),
        j(mod_only[type][arx_dir].begin());
      while(i!=orig_only[type][arx_dir].end()
            && j!=mod_only[type][arx_dir].end())
        {
          if(i->inventory_tag==j->inventory_tag)
            {
              Inventory_iterator i_old(i), j_old(j);
              ++i;
              ++j;
              orig_only[type][arx_dir].erase(i_old);
              mod_only[type][arx_dir].erase(j_old);
            }
          else if(i->inventory_tag < j->inventory_tag)
            {
              ++i;
            }
          else
            {
              ++j;
            }
        }
      type=control;
    }
}
