/* Return the target that a symbolic link points to.

  Copyright (C) 2003 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */


#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/exception.hpp"

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;


path link_target(const path &link)
{
  char buffer[PATH_MAX];
  int status=readlink(link.native_file_string().c_str(),buffer,PATH_MAX);

  if(status==-1 || status==PATH_MAX)
    {
      boost::throw_exception(fs::filesystem_error
                             ("link_target",link,
                              fs::detail::system_error_code()));
    }
  else
    {
      buffer[status]='\0';
    }
  return path(buffer);
}

    
