/* Gets all of the branches of a particular category.

   Copyright 2002, 2003 Walter Landry and the Regents of the
   University of California.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include <list>
#include <fstream>
#include <cstdio>

using namespace std;

list<string> get_branches(const string &category)
{
  string temp_name=",,branches";
  list<string> category_branch_list;
  if(!system(("arx branches --full " + category + " > " + temp_name).c_str()))
    {
      ifstream branch_file(temp_name.c_str());
      string category_branch;
      while(getline(branch_file,category_branch))
	category_branch_list.push_back(category_branch);
    }
  else
    {
      throw (string) "Can't get the branches of " + category;
    }

  if(remove(temp_name.c_str()))
    throw (string) "Can't remove " + temp_name + " in get_branches";

  return category_branch_list;
}
