/* Gets all of the categories of a particular archive.

   Copyright 2002, 2003 Walter Landry and the Regents of the
   University of California.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include <list>
#include <fstream>
#include <cstdio>

using namespace std;

list<string> get_categories(const string &archive)
{
  string temp_name=",," + archive + "--categories";
  list<string> archive_category_list;
  if(!system(("arx categories --full " + archive + " > " + temp_name).c_str()))
    {
      ifstream category_file(temp_name.c_str());
      string archive_category;
      while(getline(category_file,archive_category))
	archive_category_list.push_back(archive_category);
    }
  else
    {
      throw (string) "Can't get the categories of " + archive;
    }

  if(remove(temp_name.c_str()))
    throw (string) "Can't remove " + temp_name + " in get_categories";

  return archive_category_list;
}
