/* Gets all of the revisions of a particular version.

   Copyright 2002, 2003 Walter Landry and the Regents of the
   University of California.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include <list>
#include <fstream>
#include <cstdio>

using namespace std;

list<string> get_revisions(const string &version)
{
  string temp_name=",,revisions";
  list<string> version_revision_list;
  if(!system(("arx revisions --full " + version + " > " + temp_name).c_str()))
    {
      ifstream revision_file(temp_name.c_str());
      string version_revision;
      while(getline(revision_file,version_revision))
	version_revision_list.push_back(version_revision);
    }
  else
    {
      throw (string) "Can't get the revisions of " + version;
    }

  if(remove(temp_name.c_str()))
    throw (string) "Can't remove " + temp_name + " in get_revisions";

  return version_revision_list;
}
