/* Gets all of the versions of a particular branch.

   Copyright 2002, 2003 Walter Landry and the Regents of the
   University of California.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include <list>
#include <fstream>
#include <cstdio>

using namespace std;

list<string> get_versions(const string &branch)
{
  string temp_name=",,versions";
  list<string> branch_version_list;
  if(!system(("arx versions --full " + branch + " > " + temp_name).c_str()))
    {
      ifstream version_file(temp_name.c_str());
      string branch_version;
      while(getline(version_file,branch_version))
	branch_version_list.push_back(branch_version);
    }
  else
    {
      throw (string) "Can't get the versions of " + branch;
    }

  if(remove(temp_name.c_str()))
    throw (string) "Can't remove " + temp_name + " in get_versions";

  return branch_version_list;
}
