/* A class to hold all of the flags that might be set when
   inventorying a directory.

   Copyright 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#ifndef ARX_INVENTORY_FLAGS_HPP
#define ARX_INVENTORY_FLAGS_HPP

#include "Inventory_Method.hpp"
#include "Inventory_Regexes.hpp"
#include "inventory_types.hpp"
#include "Command_Info.hpp"

class Inventory_Flags
{
public:
  bool control, nested, use_default_inventory_method, inventory_non_source,
    source, precious, backups, junk, unrecognized, trees, report,
    directories, files, kind, tags, untagged, disambiguate;

  Inventory_Method::inventory_method inv_method;
  Inventory_Regexes regexes;

  Inventory_Flags(): control(false), nested(false),
                     use_default_inventory_method(true),
                     inventory_non_source(false),
                     source(false), precious(false), backups(false),
                     junk(false), unrecognized(false), trees(false),
                     report(false), directories(false), files(false),
                     kind(false), tags(false),
                     untagged(false), disambiguate(true){};
};

#endif
