/* A class to hold all of the regexes for deciding what type a file is
   when doing an inventory.

   Copyright 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#ifndef ARX_INVENTORY_REGEXES_HPP
#define ARX_INVENTORY_REGEXES_HPP

// #include <iostream>
// #include <string>
#include "boost/regex.hpp"
// #include "boost/filesystem/operations.hpp"
// #include "boost/filesystem/exception.hpp"
// #include "arx_error.hpp"

class Inventory_Regexes
{
public:
  boost::regex source, precious, backup, junk, unrecognized, control;

  Inventory_Regexes():
    source("^([_=a-zA-Z0-9].*|\\.arch-ids|\\{arch\\}|\\.arch-project-tree)$"),
    precious("^(\\+.*|\\.gdbinit|\\.#ckpts-lock|=build\\.*|=install\\.*|CVS|CVS\\.adm|RCS|RCSLOG|SCCS|TAGS)$"),
    backup("^.*(~|\\.~[0-9]+~|\\.bak|\\.orig|\\.rej|\\.original|\\.modified|\\.reject)$"),
    junk("^(,.*)$"),
    unrecognized("^(.*\\.(o|a|so|core)|core)$"),
    control("^(.arch-ids|\\{arch\\})$") {}

//   void set(const boost::filesystem::path &directory, const Command_Info &info)
//   {
//     try
//       {
//         boost::filesystem::fstream regex_file(tree_root(directory,info)
//                                / "{arch}/=tagging-method");

//         std::string regexes;
//         /* Skip the first line, because it just has the tagging method */
//         getline(regex_file,regexes);
//         while(getline(regex_file,regexes))
//           {
//             if(regexes.substr(0,6)=="source")
//               {
//                 source=boost::regex(regexes.substr(7));
//               }
//             else if(regexes.substr(0,8)=="precious")
//               {
//                 precious=boost::regex(regexes.substr(9));
//               }
//             else if(regexes.substr(0,6)=="backup")
//               {
//                 backup=boost::regex(regexes.substr(7));
//               }
//             else if(regexes.substr(0,4)=="junk")
//               {
//                 junk=boost::regex(regexes.substr(5));
//               }
//             else if(regexes.substr(0,12)=="unrecognized")
//               {
//                 unrecognized=boost::regex(regexes.substr(13));
//               }
//             /* The exclude regex is ignored, since it basically
//                defines the control files. */
//             else if(regexes.substr(0,7)=="exclude")
//               {
//                 if(info.verbosity>=default_output)
//                   std::cerr << "Warning: exclude regex ignored in "
//                     + (tree_root(directory,info) / "{arch}/=tagging_method")
//                     .native_file_string()
//                             << std::endl;
//               }
//             else if(!regexes.empty())
//               {
//                 throw arx_error("Can't parse tagging-method file: "
//                                 + (tree_root(directory,info)
//                                    / "{arch}/=tagging_method").native_file_string()
//                                 + "\nBad line is: \n" + regexes,info);
//               }
//           }
//       }
//     catch (boost::filesystem::filesystem_error &fs_error)
//       {
//         throw arx_error("Can't open the tagging file "
//                         + (tree_root(directory,info)
//                            / "{arch}/=tagging-method").native_file_string(),
//                         info);
//       }
//   }
};

#endif
