/* This is a one way transformation that replaces all funny characters
   with underscores "_".  This will eventually get phased out when we
   start using url-encoding.

   Copyright (C) 2001, 2002 Tom Lord
   Copyright (C) 2002, 2003 Walter Landry and the Regents of the
                                  University of California

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#ifndef ARX_TOM_ENCODE_HPP
#define ARX_TOM_ENCODE_HPP

#include <string>

inline std::string Tom_encode(const std::string &s)
{
  std::string result(s);
  /* Don't encode unprintable characters at the end. */
  for(int i=result.size()-1;i>0;--i)
    {
      unsigned char j(result[i]);
      if(j<33 || j>127)
        result.erase(i);
      else
        break;
    }

  for(unsigned int i=0;i<result.size();++i)
    {
      unsigned char j(result[i]);
      if(j<33 || j>127)
        {
          result[i]='_';
        }
    }
  return result;
}

#endif
