/* Looks recursively through a directory, categorizing what is there.
   When looking at directories, it asks, in order:

   1) Is it a nested tree
   2) Does it match the regex for a control directory
   3) Is it an explicitly tagged directory
   4) Does it match the regex for junk, then backup, then precious,
      then unrecognized, then source

   If none of these things are true, then it categorizes the directory
   as unrecognized.

   For files, it is the same except there are no such thing as nested
   trees, and it checks for implicit tags as well.

   Copyright (C) 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <list>
#include "file_attributes.hpp"
#include "Inventory_Flags.hpp"
#include "Command_Info.hpp"
#include "boost/filesystem/operations.hpp"
#include "Inventory.hpp"

extern void inventory_directory(const boost::filesystem::path &directory,
                                Inventory &result,
                                const Inventory_Flags &flags,
                                const Command_Info &info);

