/* Splits up a full_name into it's component parts: archive, category,
   etc.  The category, branch, version, and revision are returned as
   fully qualified names including the archive.

   Copyright 2002, 2003 Walter Landry and the Regents of the
   University of California.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include "Command_Info.hpp"
extern void parse_package_name(const std::string &full_name,
                               std::string &archive,
                               std::string &category, std::string &branch,
                               std::string &version, std::string &revision,
                               const Command_Info &info,
                               const bool &require_archive=false);

