/* Get an option from a file.

   Copyright 2003 Walter Landry

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA */

#include <string>
#include <list>
#include <map>
#include "boost/filesystem/operations.hpp"
#include "boost/filesystem/fstream.hpp"
#include "boost/filesystem/exception.hpp"
#include "Command_Info.hpp"
#include "arx_error.hpp"

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

string get_option_from_file(const path &config_path, const Command_Info &info)
{
  string config_option;
  try
    {
      fs::ifstream config_file(config_path);
      if(!getline(config_file,config_option))
        {
          config_option="";
        }
    }
  catch(fs::filesystem_error &fs_error)
    {
      throw arx_error("Can't open the config file:"
                      + config_path.native_file_string(),info);
    }
  return config_option;
}
