/* Recursively delete a path and its children.

  Copyright (C) 2003 Walter Landry
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 dated June, 1991.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

#include "boost/filesystem/operations.hpp"

using namespace std;
using namespace boost;
namespace fs=boost::filesystem;
using fs::path;

void recursively_delete_paths(const path &deleted_path)
{
  fs::directory_iterator dir_end;
  for(fs::directory_iterator i(deleted_path); i!=dir_end; ++i)
    {
      if(is_link(*i) || !is_directory(*i))
        {
          fs::remove(*i);
        }
      else
        {
          recursively_delete_paths(*i);
        }
    }
  fs::remove(deleted_path);
}
