// 
// mkpatch-directory-filter utility
//
// Copyright (C) 2002 Karel Gardas
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 dated June, 1991.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
// 

#include <iostream>
#include <string>
#include <fstream>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <assert.h>

using namespace std;

int
main(int argc, char* argv[])
{
    assert(argc == 4);
    string original = argv[1];
    string modified = argv[2];
    string files = argv[3];
    //cerr << argv[0] << " " << original << " " << modified << " " << files << endl;
    ifstream fin;
    fin.open(files.c_str(), ios::in);
    string orig_dir;
    string mod_dir;
    while (fin >> orig_dir
	   && fin >> mod_dir
	   && fin.good()) {
	//cerr << orig_dir << " <-> " << mod_dir << endl;
	struct stat st1;
	struct stat st2;
	int x = lstat((original + "/" + orig_dir).c_str(), &st1);
	//cerr << "x1: " << x << endl;
	x = lstat((modified + "/" + mod_dir).c_str(), &st2);
	//cerr << "x2: " << x << endl;
	if (st1.st_mode != st2.st_mode) {
	    //cerr << "permissions are different => output" << endl;
	    cout << orig_dir << " " << mod_dir << endl;
	    continue;
	}
    }
    return 0;
}
