/* tag: Scott Parish Sun Feb  2 13:03:45 2002 (dav-protocol.h)
 */
/* dav-protocol.h -
 *
 ****************************************************************
 * Copyright (C) 2002 Scott Parish
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef INCLUDE__DAV_PROTOCOL__PROTOCOL_H
#define INCLUDE__DAV_PROTOCOL__PROTOCOL_H

#include "hackerlab/machine/types.h"
#include "hackerlab/os/stdarg.h"
#include "hackerlab/mem/alloc-limits.h"

#define LISTING_FILE ".listing"


/* automatically generated __STDC__ prototypes */
extern int dav_client_connect_and_login (alloc_limits limits,
					 int * errn,
					 int * code,
					 t_uchar ** text,
					 long * text_len,
					 t_uchar * protocol,
					 t_uchar * host,
					 t_uchar * program_name,
					 t_uchar * program_version);
extern int dav_client_cwd (alloc_limits limits,
			   int * errn,
			   int * code,
			   t_uchar ** text,
			   long * text_len,
			   t_uchar * path);
extern int dav_client_cdup (alloc_limits limits,
			    int * errn,
			    int * code,
			    t_uchar ** text);
extern int dav_client_begin_retr (alloc_limits limits,
				  int * errn,
				  int * code,
				  t_uchar ** text,
				  t_uchar * path);
extern int dav_client_end_retr (alloc_limits limits,
				int * errn,
				int * code,
				t_uchar ** text);
extern int dav_client_rename (alloc_limits limits,
			      int * errn,
			      int * code,
			      t_uchar ** text,
			      t_uchar * from,
			      t_uchar * to);
extern int dav_client_unlink (alloc_limits limits,
			    int * errn,
			    int * code,
			    t_uchar ** text,
			    t_uchar * path);
extern int dav_client_rmd (alloc_limits limits,
			   int * errn,
			   int * code,
			   t_uchar ** text,
			   t_uchar * path);
extern int dav_client_mkd (alloc_limits limits,
			   int * errn,
			   int * code,
			   t_uchar ** text,
			   t_uchar * path);
extern int dav_client_pwd (alloc_limits limits,
			   int * errn,
			   int * code,
			   t_uchar ** text);
extern int dav_client_list (alloc_limits limits,
			    int * errn,
			    int * code,
			    t_uchar ** text,
			    int data_fd,
			    t_uchar *path,
			    int longfmt);
#endif  /* INCLUDE__DAV_PROTOCOL__PROTOCOL_H */
