/* tag: Tom Lord Tue Dec  4 14:41:25 2001 (command.c)
 */
/* command.c -
 *
 ****************************************************************
 * Copyright (C) 2001 Tom Lord
 * Assorted Alterations 2002 Scott Parish
 * Copyright (C) 2003 Environment Canada - Meteorological Service of Canada
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "hackerlab/vu/vu-utils.h"
#include "hackerlab/vu/printfmt-va.h"
#include "ftp-utils/clients/ftp-command.h"



int
ftp_client_printfmt (int * errn, int fd, char * fmt, ...)
{
  int answer;
  va_list ap;

#if 0
  printfmt (errn, 2, "sending: ");
  va_start (ap, fmt);
  printfmt_va_list (errn, 2, fmt, ap);
  va_end (ap);
#endif

  va_start (ap, fmt);
  answer = printfmt_va_list (errn, fd, (t_uchar *)fmt, ap);
  va_end (ap);

  if (   (answer >= 0)
      && vfdbuf_is_buffered (fd)
      && (0 > vfdbuf_flush (errn, fd)))
    return -1;

  return answer;
}

