/* ar.h - decls for variable size arrays
 *
 ****************************************************************
 * Copyright (C) 1998, 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__ARRAYS__AR_H
#define INCLUDE__ARRAYS__AR_H

#include "hackerlab/machine/types.h"
#include "hackerlab/mem/alloc-limits.h"


/* automatically generated __STDC__ prototypes */
extern int ar_size (void * base, alloc_limits limits, size_t elt_size);
extern void * ar_ref (void ** base,
		      alloc_limits limits,
		      int n,
		      int szof);
extern void ar_setsize (void ** base,
		      alloc_limits limits,
		      int n,
		      size_t szof);
extern void ar_compact (void ** base,
		      alloc_limits limits,
		      size_t szof);
extern void ar_free (void ** base, alloc_limits limits);
extern void * ar_push (void ** base,
		     alloc_limits limits,
		     size_t szof);
extern void * ar_pop (void ** base,
		    alloc_limits limits,
		    size_t szof);
extern void * ar_copy (void * base,
		     alloc_limits limits,
		     size_t szof);
#endif  /* INCLUDE__ARRAYS__AR_H */
