/* tag: Tom Lord Tue Dec  4 14:41:51 2001 (pow2-array.h)
 */
/* pow2-array.h -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef INCLUDE__ARRAYS__POW2_ARRAY_H
#define INCLUDE__ARRAYS__POW2_ARRAY_H



#include "hackerlab/mem/alloc-limits.h"



struct pow2_array_level_rule
{
  int addr_shift;
  size_t addr_mask;
};

struct pow2_array_rules
{
  void ** defaults;
  struct pow2_array_level_rule * levels;
  size_t elt_size;
};

typedef struct pow2_array_rules * pow2_array_rules;

struct pow2_array
{
  struct alloc_limits * limits;
  pow2_array_rules rules;
  void * root;
};

typedef struct pow2_array * pow2_array;



/* automatically generated __STDC__ prototypes */
extern pow2_array_rules make_pow2_array_rules (struct alloc_limits * limits,
					       size_t elt_size,
					       void * default_page,
					       int shift,
					       size_t mask,
					       ...);
extern pow2_array pow2_array_alloc (struct alloc_limits * limits,
				    pow2_array_rules rules);
extern void * pow2_array_rref (pow2_array array, size_t addr);
extern void * pow2_array_ref (pow2_array array, size_t addr);
#endif  /* INCLUDE__ARRAYS__POW2_ARRAY_H */
