/* tag: Tom Lord Tue Dec  4 14:41:35 2001 (uni-bits.c)
 */
/* uni-bits.c -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "hackerlab/bitsets/uni-bits.h"


/************************************************************************
 *(h1 "Unicode Character Bitsets")
 * 
 * 
 * 
 */

/*(c uni_bits_tree_rule :category variable)
 * struct bits_tree_rule uni_bits_tree_rule[];
 * 
 * `uni_bits_tree_rule' defines a bitset tree branching structure
 * suitable for representing sparse sets of Unicode code points.
 * (See xref:"Bitset Tree Rules".)
 * 
 * Each set has {1 << 21} elements.  
 * 
 * This tree structure has been tuned to efficiently represent
 * sets corresponding to each of the Unicode General Categories
 * of characters.  (See xref:"Unicode Category Bitsets".)
 */

struct bits_tree_rule uni_bits_tree_rule[] = {{32, 1<<16, 16, 0xffff}, {16, 1<<12, 12, 0xfff}, {16, 256, 8, 0xff}, {0, 256, 0, 0}};

