/* panic.h - decls for fatal errors
 *
 ****************************************************************
 * Copyright (C) 1998, 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__BUGS__PANIC_H
#define INCLUDE__BUGS__PANIC_H


#include "hackerlab/machine/types.h"
#include "hackerlab/bugs/panic-exit.h"


#define invariant_4(CONDITION, MSG, FILE, LINE) \
	invariant_test (CONDITION, MSG, FILE, LINE)

#define invariant_2(CONDITION, MSG) \
	invariant_4 (CONDITION, MSG, __FILE__, __LINE__)

#define invariant__x(CONDITION) \
	invariant_4 (CONDITION, #CONDITION, __FILE__, __LINE__)

#define invariant(CONDITION) \
	invariant__x(CONDITION)

#define invariant_at_file_linex(CONDITION, FILE, LINE) \
	invariant_test (CONDITION, #CONDITION, FILE, LINE)

#define invariant_at_file_line(CONDITION, FILE, LINE) \
	invariant_at_file_linex(CONDITION, FILE, LINE)



/* automatically generated __STDC__ prototypes */
extern void panic (char * str);
extern void panic_msg (char * str);
extern void invariant_test (int condition, char * str, char * file, int line);
#endif  /* INCLUDE__BUGS__PANIC_H */
