/* tag: Tom Lord Tue Dec  4 14:41:26 2001 (test-coverage.h)
 */
/* test-coverage.h -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef INCLUDE__BUGS__TEST_COVERAGE_H
#define INCLUDE__BUGS__TEST_COVERAGE_H


#include "hackerlab/bugs/panic.h"



/* example:
 *
 * #define TEST_COVERAGE_LIST(MACRO) \
 *   TEST_COVERAGE_ ## MACRO (name1); \
 *   TEST_COVERAGE_ ## MACRO (name2); \
 *   ...			      \
 *   TEST_COVERAGE_ ## MACRO (name2) \
 *
 *
 * TEST_COVERAGE_LIST(DECL);
 *
 *
 * {
 * 	...
 *   TEST_COVERED(name_n);
 * 
 * }
 * 
 * 
 *
 * {
 *    TEST_COVERAGE_LIST(CHECK);
 *    exit (0);
 * }
 */

#define TEST_COVERAGE_DECL(NAME) 	static int NAME = 0
#define TEST_COVERAGE_CHECK(NAME)	if (!NAME) panic ("test coverage failure: " #NAME)
#define TEST_COVERED(NAME)  NAME = 1



/* automatically generated __STDC__ prototypes */
#endif  /* INCLUDE__BUGS__TEST_COVERAGE_H */
