/* tag: Tom Lord Tue Dec  4 14:41:26 2001 (=names.c)
 */
/* =names.c - generate a list of character names
 *
 ****************************************************************
 * Copyright (C) 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */



/* This is handy for generating part of "chrname.c"
 *
 * cc -o =names =names.c ; ./=names ; rm =names
 *
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

int
main (int argc, char ** argv)
{
  int x;

  x = 0;
  while (x < 256)
    {

      if (x == '\\')
	fputs ("  \"\\\\\\\\\",", stdout);
      else if (x == '"')
	fputs ("  \"\\\\\\\"\",", stdout);
      else if (isprint (x))
	printf ("  \"%c\",", x);
      else
	{
	  switch (x)
	    {
	    default:
	      printf ("  \"\\\\0%o\",", x);
	      break;
	    case '\n':
	      fputs ("  \"\\\\n\",", stdout);
	      break;
	    case '\t':
	      fputs ("  \"\\\\t\",", stdout);
	      break;
	    case '\f':
	      fputs ("  \"\\\\f\",", stdout);
	      break;
	    }
	}
      ++x;
      if (!(x % 8))
	putchar ('\n');
    }
  putchar ('\n');
  return 0;
}
