/* str.h - decls for string functions
 *
 ****************************************************************
 * Copyright (C) 1998, 2000 Thomas Lord
 * Modifications 2002 placed in public domain by Scott Parish
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__CHAR__STR_H
#define INCLUDE__CHAR__STR_H



#include "hackerlab/machine/types.h"
#include "hackerlab/mem/alloc-limits.h"



extern t_uchar str_end[];


/* automatically generated __STDC__ prototypes */
extern size_t str_length (const t_uchar * x);
extern size_t str_length_n (const t_uchar * x, size_t n);
extern unsigned long str_hash_n (const t_uchar * chr, size_t len);
extern t_uchar * str_chr_index (const t_uchar * s, int c);
extern t_uchar * str_chr_rindex (const t_uchar * s, int c);
extern t_uchar * str_chr_index_n (const t_uchar * s, size_t n, int c);
extern t_uchar * str_chr_rindex_n (const t_uchar * s, size_t n, int c);
extern int str_cmp (const t_uchar * a, const t_uchar * b);
extern int str_cmp_n (const t_uchar * a, size_t a_l, const t_uchar * b, size_t b_l);
extern int str_cmp_prefix (const t_uchar * prefix, const t_uchar * s);
extern int str_casecmp (const t_uchar * a, const t_uchar * b);
extern int str_casecmp_n (const t_uchar * a, size_t a_l,
			  const t_uchar * b, size_t b_l);
extern int str_casecmp_prefix (const t_uchar * prefix, const t_uchar * s);
extern t_uchar * str_cpy (t_uchar * to, const t_uchar * from);
extern t_uchar * str_cpy_n (t_uchar * to,
			    const t_uchar * from,
			    size_t n);
extern t_uchar * str_cat (t_uchar * to, const t_uchar * from);
extern t_uchar * str_cat_n (t_uchar * to,
			    const t_uchar * from,
			    size_t n);
extern t_uchar * str_save (alloc_limits limits, const t_uchar * str);
extern t_uchar * str_save_n (alloc_limits limits,
			     const t_uchar * str,
			     size_t len);
extern t_uchar * str_alloc_cat (alloc_limits limits,
				const t_uchar * str1,
				const t_uchar * str2);
extern t_uchar * str_alloc_cat_n (alloc_limits limits,
				  const t_uchar * str1,
				  const t_uchar * str2,
				  size_t n);
extern t_uchar * str_realloc_cat (alloc_limits limits,
				  t_uchar * str1,
				  const t_uchar * str2);
extern t_uchar * str_realloc_cat_n (alloc_limits limits,
				    t_uchar * str1,
				    const t_uchar * str2,
				    size_t n);
extern t_uchar * str_cat_many (t_uchar * to, ...);
extern t_uchar * str_alloc_cat_many (alloc_limits limits,
				     ...);
extern t_uchar * str_realloc_cat_many (alloc_limits limits,
				       t_uchar * str1,
				       ...);
#endif  /* INCLUDE__CHAR__STR_H */
