/* cvt.h - declarations for integer/string conversions
 *
 ****************************************************************
 * Copyright (C) 1998, 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__FMT__CVT_H
#define INCLUDE__FMT__CVT_H



#include "hackerlab/machine/types.h"



/* automatically generated __STDC__ prototypes */
extern void cvt_ulong_to_decimal (t_uchar * nbuf, unsigned long n);
extern void cvt_long_to_decimal (t_uchar * nbuf, long n);
extern void cvt_ulong_to_octal (t_uchar * nbuf, unsigned long n);
extern void cvt_long_to_octal (t_uchar * nbuf, long n);
extern void cvt_ulong_to_HEX (t_uchar * nbuf, unsigned long n);
extern void cvt_long_to_HEX (t_uchar * nbuf, long n);
extern void cvt_ulong_to_hex (t_uchar * nbuf, unsigned long n);
extern void cvt_long_to_hex (t_uchar * nbuf, long n);
extern int cvt_decimal_to_ulong (int * errn, unsigned long * answerp, const t_uchar * text, size_t len);
extern int cvt_decimal_to_uint (int * errn, unsigned int * answerp, const t_uchar * text, size_t len);
extern int cvt_decimal_to_long (int * errn, long * answerp, const t_uchar * text, size_t len);
extern int cvt_decimal_to_int (int * errn, int * answerp, const t_uchar * text, size_t len);
extern int cvt_hex_to_ulong (int * errn, unsigned long * answerp, const t_uchar * text, size_t len);
extern int cvt_hex_to_uint (int * errn, unsigned int * answerp, const t_uchar * text, size_t len);
extern int cvt_hex_to_long (int * errn, long * answerp, const t_uchar * text, size_t len);
extern int cvt_hex_to_int (int * errn, int * answerp, const t_uchar * text, size_t len);
extern int cvt_octal_to_ulong (int * errn,
			       unsigned long * answerp,
			       const t_uchar * text,
			       size_t len);
extern int cvt_octal_to_uint (int * errn, unsigned int * answerp, const t_uchar * text, size_t len);
extern int cvt_octal_to_long (int * errn, long * answerp, const t_uchar * text, size_t len);
extern int cvt_octal_to_int (int * errn, int * answerp, const t_uchar * text, size_t len);
#endif  /* INCLUDE__FMT__CVT_H */
