/* file-names.h - decls for file-name manipulations
 *
 ****************************************************************
 * Copyright (C) 1998, 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__FS__FILE_NAMES_H
#define INCLUDE__FS__FILE_NAMES_H



#include "hackerlab/machine/types.h"
#include "hackerlab/mem/alloc-limits.h"


/* automatically generated __STDC__ prototypes */
extern t_uchar * file_name_home_directory (void);
extern int file_name_is_absolute (t_uchar * f);
extern t_uchar * file_name_tilde_expand (alloc_limits limits, t_uchar * fname);
extern t_uchar * file_name_tail (alloc_limits limits, t_uchar * fname);
extern t_uchar * file_name_as_directory (alloc_limits limits, t_uchar * f);
extern t_uchar * file_name_from_directory (alloc_limits limits, t_uchar * f);
extern t_uchar * file_name_directory (alloc_limits limits, t_uchar * f);
extern t_uchar * file_name_in_vicinity (alloc_limits limits,
					t_uchar * dir,
					t_uchar * name);
extern t_uchar ** path_parse (alloc_limits limits, t_uchar * path);
extern void free_path (alloc_limits limits, t_uchar ** path);
extern t_uchar * path_find_executable (alloc_limits limits,
				       t_uchar ** path,
				       t_uchar * tail);
#endif  /* INCLUDE__FS__FILE_NAMES_H */
