#!/bin/sh
# tag: Tom Lord Tue Dec  4 14:54:41 2001 (machine/endian.sh)
#

CC="$1"

cat > endian-test.c << EOF

main()
{
  unsigned int x = 1;

  exit (*(unsigned char *)&x);
}
 
EOF

cat > ,tmp << EOF
/* endian.h - endianness
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef INCLUDE__MACHINE__ENDIAN_H
#define INCLUDE__MACHINE__ENDIAN_H

#define MACHINE_IS_BIGENDIAN  @BIG@


/* automatically generated __STDC__ prototypes */
#endif  /* INCLUDE__MACHINE__ENDIAN_H */
EOF

$CC -o endian-test endian-test.c

if ./endian-test ; then
  sed -e s/@BIG@/1/ ,tmp > endian.h
else
  sed -e s/@BIG@/0/ ,tmp > endian.h
fi

rm ,tmp

