/* tag: Tom Lord Tue Dec  4 14:41:29 2001 (malloc.h)
 */
/* malloc.h -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef INCLUDE__OS__MALLOC_H
#define INCLUDE__OS__MALLOC_H


/* An alternative to <stdlib.h> for declaring `malloc' and
 * friends.
 * 
 * Most hackerlab code should not use `malloc' directly.
 * Instead, use "hackerlab/mem/alloc-limits.h"
 */

#include "hackerlab/machine/types.h"

extern void * calloc (size_t nmemb, size_t size);
extern void free (void * ptr);
extern void * malloc (size_t size);
extern void * realloc (void * ptr, size_t size);


/* automatically generated __STDC__ prototypes */
#endif  /* INCLUDE__OS__MALLOC_H */
