/* limits.h - Corrections to <limits.h> for Rx.
 *
 ****************************************************************
 * Copyright (C) 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__RX_POSIX__LIMITS_H
#define INCLUDE__RX_POSIX__LIMITS_H


/* Posix.2 requires regexp implementations to define `RE_DUP_MAX'
 * but unfortunately specifies that it should be defined in "<limits.h>".
 * 
 * If Rx is not the default implementation on a system, the value
 * in "<limits.h>" may not be correct.
 * 
 * Applications substituting Rx for the native implementation can
 * use the following sequence of includes to obtain declarations
 * for both the Posix regex functions and RE_DUP_MAX:
 * 
 * 	#include <sys/types.h>
 * 	#include <limits.h>
 * 	#include "hackerlab/rx-posix/limits.h"
 * 	#include "hackerlab/rx-posix/regex.h"
 * 
 */

#include "hackerlab/rx-posix/dup-max.h"

#undef RE_DUP_MAX
#define RE_DUP_MAX	RX_DUP_MAX


/* automatically generated __STDC__ prototypes */
#endif  /* INCLUDE__RX_POSIX__LIMITS_H */
