/* re8-parse.h - decls for compiling regexp syntax to rx_exp_node trees
 *
 ****************************************************************
 * Copyright (C) 1998, 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#ifndef INCLUDE__RX_POSIX__RE8_PARSE_H
#define INCLUDE__RX_POSIX__RE8_PARSE_H



#include "hackerlab/machine/types.h"
#include "hackerlab/rx/tree.h"
#include "hackerlab/rx-posix/errnorx.h"



/* The interface for translating a regexp string to 
 * a regexp syntax tree.
 */

extern const t_uchar rx_case_fold_translation_table[];
extern const t_uchar rx_id_translation_table[];



/* automatically generated __STDC__ prototypes */
extern int rx_parse (struct rx_exp_node ** rx_exp_p,
		     int * nsub,
		     const t_uchar * pattern,
		     size_t size,
		     int extended_p,
		     int newline_separates_lines,
		     int dfa_only,
		     int cset_size,
		     const t_uchar * translate);
#endif  /* INCLUDE__RX_POSIX__RE8_PARSE_H */
