/* tag: Tom Lord Tue Dec  4 14:41:37 2001 (nfa-cache.h)
 */
/* nfa-cache.h -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef INCLUDE__RX__NFA_CACHE_H
#define INCLUDE__RX__NFA_CACHE_H


#include "hackerlab/mem/alloc-limits.h"


/* automatically generated __STDC__ prototypes */
extern void rx_free_some_nfa_memory (void * ign, size_t needed);
extern alloc_limits rx_nfa_cache_limits (void);
extern void rx_set_nfa_cache_threshold (size_t n);
extern size_t rx_nfa_cache_threshold (void);
extern void rx_set_nfa_cache_failure_pt (size_t n);
extern size_t rx_nfa_cache_failure_pt (void);
extern size_t rx_nfa_cache_in_use (void);
extern size_t rx_nfa_cache_high_water_mark (void);
extern void rx_nfa_cache_statistics (size_t * threshold,
				     size_t * ign,
				     size_t * in_use,
				     size_t * high_water_mark,
				     int * hits,
				     int * misses,
				     int * ign2);
extern size_t rx_flush_nfa_cache (void);
extern void * rx_nfa_cache_malloc (size_t size);
extern void * rx_nfa_cache_soft_malloc (size_t size);
extern void * rx_nfa_cache_realloc (void * prev, size_t size);
extern void rx_nfa_cache_free (void * mem);
#endif  /* INCLUDE__RX__NFA_CACHE_H */
