/* tag: Tom Lord Tue Dec  4 14:41:40 2001 (safe-printfmt.c)
 */
/* safe-printfmt.c -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * Copyright (C) 2003 Environment Canada - Meteorological Service of Canada
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "hackerlab/os/errno-to-string.h"
#include "hackerlab/bugs/panic.h"
#include "hackerlab/vu/safe-printfmt.h"



/*(c safe_printfmt)
 * void safe_printfmt (int fd, char * fmt, ...);
 * 
 * See xref:"printfmt".
 */
void
safe_printfmt (int fd, char * fmt, ...)
{
  int errn;
  int answer;
  va_list ap;

  va_start (ap, fmt);
  answer = printfmt_va_list (&errn, fd, (t_uchar *)fmt, ap);
  va_end (ap);
  if (0 > answer)
    {
      printfmt (&errn, 2, "Error in `printfmt' (%s)\n", errno_to_string (errn));
      panic ("I/O error");
    }
}


void
safe_printfmt_va_list (int fd, char * fmt, va_list ap)
{
  int errn;
  int answer;

  answer = printfmt_va_list (&errn, fd, (t_uchar *)fmt, ap);
  if (0 > answer)
    {
      printfmt (&errn, 2, "Error in `printfmt_va_list' (%s)\n", errno_to_string (errn));
      panic ("I/O error");
    }
}

