/* tag: Tom Lord Tue Dec  4 14:41:41 2001 (safe-vu-utils-vfdbuf.c)
 */
/* safe-vu-utils-vfdbuf.c -
 *
 ****************************************************************
 * Copyright (C) 2000 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "hackerlab/os/errno.h"
#include "hackerlab/os/errno-to-string.h"
#include "hackerlab/bugs/panic.h"
#include "hackerlab/vu/printfmt.h"
#include "hackerlab/vu/safe-vu-utils-vfdbuf.h"




void
safe_next_line (t_uchar ** line, long * len, int fd)
{
  int errn;
  int status;

 retry:
  status = vfdbuf_next_line (&errn, line, len, fd);
  if (status < 0)
    {
      if (errn == EAGAIN)
	goto retry;
      printfmt (&errn, 2, "Error during call to `vfdbuf_next_line'\n");
      printfmt (&errn, 2, "  error %d: %s\n", errn, errno_to_string (errn));
      panic ("I/O error");
    }
}
