/* vu-bad-arg.c - the EINVAL file system
 *
 ****************************************************************
 * Copyright (C) 1999, 2000 Thomas Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "hackerlab/os/errno.h"
#include "hackerlab/vu/vu-bad-arg.h"


/************************************************************************
 *(h0 "A VU Handler that Always Returns an Error")
 * 
 */




/*(c vu_bad_arg)
 * int vu_bad_arg (int * errn, ...);
 * 
 * Return -1 and set `*errn' to `EINVAL'.
 * 
 * This function is useful when implementing VU handler vtables in
 * which not every VU function is supported.
 */
int
vu_bad_arg (int * errn, ...)
{
  *errn = EINVAL;
  return -1;
}


#define VU_FS_NAME_BAD_ARG(name, prefix, middle, suffix, ret, proto) ((ret(*)proto)vu_bad_arg),

struct vu_fs_discipline _vu_bad_arg_functions \
  = { VU_MAP_FS_NAMES (_BAD_ARG, , , , ) };

