/* log.c: 
 *
 ****************************************************************
 * Copyright (C) 2002 Tom Lord
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 dated June, 1991.

 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */


#include "hackerlab/vu/safe-printfmt.h"
#include "hackerlab/os/unistd.h"
#include "hackerlab/os/fcntl.h"
#include "hackerlab/vu/safe.h"
#include "shell-utils/log.h"



void
log_event (char * file, int mode, char * fmt, ...)
{
  int fd;
  struct flock lock_data;
  va_list ap;

  
  fd = safe_open (file, O_WRONLY | O_APPEND | O_CREAT, mode);

  lock_data.l_type = F_WRLCK;
  lock_data.l_whence = SEEK_SET;
  lock_data.l_start = 0;
  lock_data.l_len = 0;
  safe_fcntl (fd, F_SETLKW, (long)&lock_data);
  
  va_start (ap, fmt);
  safe_printfmt_va_list (fd, fmt, ap);
  va_end (ap);

  safe_close (fd);
}


/* tag: Tom Lord Thu Jan 24 22:19:46 2002 (log.c)
 */
