#!/bin/sh

# Make sure that arx-move handles all of the cases correctly.

# First check things if they are not in a project tree

# Copyright 2003 Walter Landry

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

mkdir hello
cd hello
touch bar baz bax
mkdir ddd
arx move bar gag
arx move ba* ddd
arx move gag ddd/
arx move ddd/* .
mkdir eee
arx move gag bar
arx move ba* eee
arx move eee/* ddd/
cd ddd
arx move * ..
arx move ../ba* .
arx move * ../eee
arx move ../eee/bar gag
cd ..
arx move ddd/gag bar
arx move eee/* .

# Then check things if they are in a project tree, including moving
# between trees

arx create-version --non-interactive hello--main--1.0
arx add ba*

cd ddd
arx create-version --nested --non-interactive hello--ddd--1.0
touch bah
arx add bah

cd ../eee
arx create-version --nested --non-interactive hello--eee--1.0
touch baj
arx add baj

cd ..
arx move bar gag
arx tree-lint
arx move ba* ddd
arx tree-lint
arx move gag ddd/
arx tree-lint
arx move ddd/[a-z]* .
arx tree-lint
arx move gag bar
arx tree-lint
arx move ba* eee
arx tree-lint
arx move eee/[a-z]* ddd/
arx tree-lint
cd ddd
arx tree-lint
arx move [a-z]* ..
arx tree-lint
arx move ../ba* .
arx tree-lint
arx move [a-z]* ../eee
arx tree-lint
arx move ../eee/bar gag
arx tree-lint
cd ..
arx tree-lint
arx move ddd/gag bar
arx tree-lint
arx move eee/[a-z]* .
arx tree-lint

# Cleanup

cd ..
rm -rf hello
