#!/bin/sh

# Written by Robert Collins 2002
# Released to public domain
# Modified 2003 Walter Landry and the Regents of the University of California

rm -rf foobar
rm -rf basis
rm -rf got

arx register-archive -d foo@bar
arx make-archive foo@bar foobar || exit 1

mkdir basis || exit 1
cd basis || exit 1
echo "Summary: basis
" > `arx create-version --non-interactive foo@bar/basis--branch--1.0` || exit 1

arx tagging-method explicit
arx naming-convention backup "^.*(~|\.~[0-9]+~|\.bak|\.orig|\.rej|\.original|\.modified|\.reject|\.#.*)$"
arx naming-convention precious "^(\+.*|\.gdbinit|=build\.*|=install\.*|CVS\.adm|RCS|RCSLOG|SCCS|TAGS)$"
arx naming-convention source "^([_=a-zA-Z0-9].*|\.arch-ids|\{arch\}|\.arch-project-tree|\.cvsignore)$"
arx naming-convention junk "^(Makefile\.in|autom4te\.cache|aclocal\.m4|compile|config\.guess|config\.sub|depcomp|install-sh|missing|mkinstalldirs|configure)$"

echo "foo" > .cvsignore
echo "bar" > bar
echo "If no warning is shown, something is wrong"
arx tree-lint || exit 1
arx add .cvsignore || exit 1
arx add bar || exit 1
echo "if a warning is shown, something is wrong"
arx tree-lint || exit 1
arx commit || exit 1
cd .. 

arx get foo@bar/basis--branch--1.0 got || exit 1
cd got || exit 1
echo "foo" >> bar || exit 1
echo "Summary: foo
Keywords: test

Foo" > `arx make-log --non-interactive` || exit 1
arx commit || exit 1
cd .. || exit 1
arx update --in-place basis || exit 1
if ! test -e basis/.cvsignore; then 
    exit 1
fi
echo "test passed"

rm -rf foobar
rm -rf basis
rm -rf got

